#include "ST7735S_SPI.h"
#include "delay.h"
/*
P1.4 = SS(CS)
P1.5 = MOSI
P1.6 = MISO
P1.7 = SCLK
*/


void LCD_SPI_Init(void)
{
	
		LCD_CS = 1;
    SPDAT=0;//ݼĴ0
    SPCTL=0xDC|4;//1101 11xx ģʽ,ʹ,ȴλ,ǰʱΪ½,½,ؼ
    SPSTAT = 0xc0;                              //жϱ־

 
}	



/*


*/

void LCD_WR_DATA8(unsigned char d8)
{

	LCD_CS = 0;
	SPDAT = d8;
	while(!(SPSTAT & 0x80));
	SPSTAT = 0xC0;
	LCD_CS = 1;
}
/*


*/
void LCD_WR_DATA(unsigned int d16)
{	
	LCD_WR_DATA8(d16>>8);
	LCD_WR_DATA8(d16);
}
/*


*/

void LCD_WR_REG(unsigned int reg)
{
	LCD_DC = 0;//д
	delay_ms(1);
	LCD_WR_DATA8(reg);
	delay_ms(1);
	LCD_DC = 1;//д
}


/*


*/

void LCD_Init(void)
{	
	LCD_RES = 1;
	delay_ms(50);
	LCD_RES = 0;//λ
	delay_ms(100);
	LCD_RES = 1;
	delay_ms(50);
	LCD_BLK = 1;
	delay_ms(20);
	//************* Start Initial Sequence **********//
	LCD_WR_REG(0x11); //Sleep out 
	delay_ms(120);              //Delay 120ms 
	//------------------------------------ST7735S Frame Rate-----------------------------------------// 
	LCD_WR_REG(0xB1); 
	LCD_WR_DATA8(0x05); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_REG(0xB2); 
	LCD_WR_DATA8(0x05);
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_REG(0xB3); 
	LCD_WR_DATA8(0x05); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x05); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	//------------------------------------End ST7735S Frame Rate---------------------------------// 
	LCD_WR_REG(0xB4); //Dot inversion 
	LCD_WR_DATA8(0x03); 
	//------------------------------------ST7735S Power Sequence---------------------------------// 
	LCD_WR_REG(0xC0); 
	LCD_WR_DATA8(0x28); 
	LCD_WR_DATA8(0x08); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_REG(0xC1); 
	LCD_WR_DATA8(0XC0); 
	LCD_WR_REG(0xC2); 
	LCD_WR_DATA8(0x0D); 
	LCD_WR_DATA8(0x00); 
	LCD_WR_REG(0xC3); 
	LCD_WR_DATA8(0x8D); 
	LCD_WR_DATA8(0x2A); 
	LCD_WR_REG(0xC4); 
	LCD_WR_DATA8(0x8D); 
	LCD_WR_DATA8(0xEE); 
	//---------------------------------End ST7735S Power Sequence-------------------------------------// 
	LCD_WR_REG(0xC5); //VCOM 
	LCD_WR_DATA8(0x1A); 
	LCD_WR_REG(0x36); //MX, MY, RGB mode 
	LCD_WR_DATA8(0x00);
	//------------------------------------ST7735S Gamma Sequence---------------------------------// 
	LCD_WR_REG(0xE0); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_DATA8(0x22); 
	LCD_WR_DATA8(0x07); 
	LCD_WR_DATA8(0x0A); 
	LCD_WR_DATA8(0x2E); 
	LCD_WR_DATA8(0x30); 
	LCD_WR_DATA8(0x25); 
	LCD_WR_DATA8(0x2A); 
	LCD_WR_DATA8(0x28); 
	LCD_WR_DATA8(0x26); 
	LCD_WR_DATA8(0x2E); 
	LCD_WR_DATA8(0x3A); 
	LCD_WR_DATA8(0x00); 
	LCD_WR_DATA8(0x01); 
	LCD_WR_DATA8(0x03); 
	LCD_WR_DATA8(0x13); 
	LCD_WR_REG(0xE1); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_DATA8(0x16); 
	LCD_WR_DATA8(0x06); 
	LCD_WR_DATA8(0x0D); 
	LCD_WR_DATA8(0x2D); 
	LCD_WR_DATA8(0x26); 
	LCD_WR_DATA8(0x23); 
	LCD_WR_DATA8(0x27); 
	LCD_WR_DATA8(0x27); 
	LCD_WR_DATA8(0x25); 
	LCD_WR_DATA8(0x2D); 
	LCD_WR_DATA8(0x3B); 
	LCD_WR_DATA8(0x00); 
	LCD_WR_DATA8(0x01); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_DATA8(0x13); 
	//------------------------------------End ST7735S Gamma Sequence-----------------------------// 
	LCD_WR_REG(0x3A); //65k mode 
	LCD_WR_DATA8(0x05); 
	LCD_WR_REG(0x29); //Display on 
} 

/*


*/

void LCD_Address_Set(unsigned int x1,unsigned int y1,unsigned int x2,unsigned int y2)
{
		LCD_WR_REG(0x2a);//еַ
		LCD_WR_DATA(x1+2);
		LCD_WR_DATA(x2+2);
		LCD_WR_REG(0x2b);//еַ
		LCD_WR_DATA(y1+1);
		LCD_WR_DATA(y2+1);
		LCD_WR_REG(0x2c);//д
}
/*


*/


void LCD_writeColor(unsigned int color)
{

	LCD_WR_DATA8(color>>8);
	LCD_WR_DATA8(color);

}/*


*/
void LCD_clear(unsigned int color)
{
	unsigned long i;
	LCD_Address_Set(0,0,159,127);
	LCD_WR_REG(0x2C);
	for(i=0;i<20480;i++)
	{
		LCD_writeColor(color);
	}
}	